"""

This simple GUI is used to establish a basic communication with the RFID Reader.
Using this application you can read the EPC, TID and User Memory of a tag and
also you can write the User memory.

"""

#!/usr/bin/env python

import wx
import pdb


class Example(wx.Frame):
           
    def __init__(self, *args, **kw):
        super(Example, self).__init__(*args, **kw) 
        
        self.InitUI()
        
    def InitUI(self):

        #method to read the memory bank
        def showMemory(event):
            
            i = cb.GetValue()
            self.dispMem.Clear()
            if i == 'EPC':
                epc = Scan()
                self.dispMem.WriteText(epc)
            elif i == 'TID':
                tid = TagID()        
                self.dispMem.WriteText(tid)
            elif i == 'User Memory':
                usermem = ReadUserMem()
                self.dispMem.WriteText(usermem)
            else:
                text = 'Please select the Memory to Read'
                self.dispMem.WriteText(text)
                
        #method to write the memory bank
        def getData(event):
            i = cb.GetValue()
            if i == 'User Memory':
                 data = self.dispMem.GetValue()
                 datahex = data.encode('hex')
                 from ReaderMain import WriteUserMemory
                 reply = WriteUserMemory(datahex)
                 self.dispMem.Clear()
                 self.dispMem.WriteText(reply)            
            else:
                self.dispMem.Clear()
                text = 'Please select the right Memory to Write'
                self.dispMem.WriteText(text)

        #Clear the display
        def dispClear(event):
            self.dispMem.Clear()
                
        #Call the function to read EPC
        def Scan():
            from ReaderMain import SingleInventory
            epc = SingleInventory()
            return epc
        
        #Call the function to read TID
        def TagID():
            from ReaderMain import ReadTagID
            tagid = ReadTagID()
            return tagid
        
        #Call the function to read User Memory
        def ReadUserMem():
            from ReaderMain import ReadUserMemory
            data = ReadUserMemory()
            return data

        
        pnl = wx.Panel(self, -1)

        
        MemoryList = ['EPC', 'TID', 'User Memory']
        cb = wx.ComboBox(pnl, 500, "Please select", pos = (10,80),
                         choices = MemoryList,
                         style = wx.CB_READONLY)
        MemValue = cb.GetValue()
        cb.SetValue(MemValue)   
       
        self.dispMem = wx.TextCtrl(pnl, -1, pos = (10,20), size = (380,40))
        self.dispMem.Bind(wx.EVT_BUTTON, dispClear)
                
        ReadBtn = wx.Button(pnl, label = 'Read', pos = (200,75))
        ReadBtn.Bind(wx.EVT_BUTTON, showMemory)

        WriteBtn = wx.Button(pnl, label = 'Write', pos = (300,75))
        WriteBtn.Bind(wx.EVT_BUTTON, getData)

                             
        self.SetSize((400, 130))
        self.SetTitle('RFID')
        self.Centre()
        self.Show(True)

    
        
def main():
    
    ex = wx.App()
    Example(None)
    ex.MainLoop()    


if __name__ == '__main__':
    main()  
