"""
This is the main program which consists of every fucntion for each commands
"""

import serial
import time
import pdb
import struct
import binascii

#defining the port and its parameters
ser = serial.Serial('/dev/ttyAMA0',
                    baudrate=115200,
                    bytesize=8,
                    parity='N',
                    timeout=0,
                    xonxoff=False,
                    rtscts=False,
                    writeTimeout=10,
                    dsrdtr=False,)

#Open serial port
"""
try:
    ser.open()
    
except Exception, e:
        
    print "Error opening Serial port: " +str(e)
    exit()"""
#-------------------------------------------------------------------------------
#method to Read EPC
 
def SingleInventory():
    #ser.open()
    if ser.isOpen():
        try:
            start = time.time()
            
            cmdReadEPC = "524645015001020004"
            from ReaderFunctions import CheckSum
            cmdReadEPCCS = CheckSum(cmdReadEPC) #Calculate the checksum            
            cmd = binascii.unhexlify(cmdReadEPCCS)            
            from ReaderFunctions import SerialComm            
            EPCdata = SerialComm(ser,cmd) #Write & Read Serial port
            idCount = EPCdata[20:22] #'00' #11th byte
            count = 0
            
            #if EPC is not read try again
            while idCount == '00' or len(EPCdata) != 58:
                if count < 5:
                    EPCdata = SerialComm(ser, cmd) #ReadSerial(ser)
                    idCount = EPCdata[20:22]
                    count = count + 1
                    
                else:                    
                    break
            #Analyze the serial data     
            EPClen = EPCdata[28:30] #15th byte
            if EPCdata and EPClen == '0c':            
                startByte = 30 #16th byte
                endByte = startByte + (2*int(EPClen,16))
                Epc = EPCdata[startByte:endByte]
                EPC = '-'.join([Epc[i:i+2] for i in range (0,len(Epc),2)])                
                return EPC
                
            else:
                return "Tag Unreachable"
            ser.close()
        
        except Exception, e1:
            return "Error Communicating...: "+str(e1)

    else:
        print"Cannot open serial port"

#-------------------------------------------------------------------------------
#method to Read TagID
 
def ReadTagID():
    #ser.open()
    if ser.isOpen():
        start = time.time()
        EPC = SingleInventory()
        if ' ' in EPC:
            return 'Tag unreachable'

        else:
            EPC = EPC.replace('-','')
            cmdReadTagID = '5246450150030215030c'+EPC+'020001000000000604'
            from ReaderFunctions import CheckSum            
            cmdReadTagIDCS = CheckSum(cmdReadTagID) #Calculate the checksum            
            cmd = binascii.unhexlify(cmdReadTagIDCS)
            from ReaderFunctions import SerialComm
       
            TagIDdata = SerialComm(ser, cmd) #establish serial communication
            status = TagIDdata[18:20]
            count = 0
            
            #Method to analyze the serial data
            def tagid(data):
                bytesCount = TagIDdata[20:22]
                startByte = 22
                endByte = startByte + (2*int(bytesCount,16))
                Tagid = TagIDdata[startByte:endByte]
                first2Bytes = 'e200'
                TagID = first2Bytes + Tagid
                TagID = '-'.join([TagID[i:i+2] for i in range (0,len(TagID),2)])
                return TagID
            #if data not read try again 
            if len(TagIDdata) == 38:
                tid = tagid(TagIDdata)
                
                return tid
                
            else:
                while status != '00' or len(TagIDdata)!= 38:
                    if count < 15:
                        TagIDdata = SerialComm(ser, cmd)
                        status = TagIDdata[18:20]
                        count = count + 1
                        
                    else:
                        
                        break                            

                if status == '00':
                    tid = tagid(TagIDdata)
                    
                    return tid
                else:
                    return "Tag unreachable"

            ser.close()
 
    else:
        print"Cannot open serial port"

#-------------------------------------------------------------------------------
#method to Read User Memory
 
def ReadUserMemory():
    
    if ser.isOpen():
        start = time.time()
        EPC = SingleInventory()
        
        if ' ' in EPC:
            return 'Tag unreachable'

        else:
            EPC = EPC.replace('-','')
            cmdReadUserMemory = '5246450150030215030c'+EPC+'030000000000004004'
            from ReaderFunctions import CheckSum            
            cmdReadUserMemoryCS = CheckSum(cmdReadUserMemory) #Calculate the checksum            
            cmd = binascii.unhexlify(cmdReadUserMemoryCS)
            from ReaderFunctions import SerialComm
            
            data = SerialComm(ser, cmd) #Establish serial communication
            
            status = data[18:20]
            count = 0
            
            #method to analyze serial data
            def usermem(datamem):
                bytesCount = datamem[20:22]
                startByte = 22
                endByte = startByte + (2*int(bytesCount,16))
                Memory = datamem[startByte:endByte]
                UserMemory = Memory.decode('hex')
                return UserMemory

            
            #if data not read try again    
            if len(data) == 154:
                UserMemory = usermem(data)
                
                return UserMemory
            else:
                while status != '00' or len(data)!= 154:
                    if count < 15:
                        data = SerialComm(ser, cmd)
                        status = data[18:20]
                        count = count + 1
                        
                        
                    else:
                        
                        break                            

                if status == '00':
                    UserMemory = usermem(data)                    
                    return UserMemory
                else:
                    return "Tag unreachable"                              
        
        
    else:
        print"Cannot open serial port"

#-------------------------------------------------------------------------------

#method to Write User Memory
def WriteUserMemory(data):
    #ser.open()
    
    if ser.isOpen():
        start = time.time()
        EPC = SingleInventory()
        if ' ' in EPC:
            return 'Tag unreachable'

        else:
            
            EPC = EPC.replace('-','')

            data = data.ljust(128,'0')
            bytesCount = len(data)/2
            restDataCount = (len(EPC)/2) + 9
            datalength = hex(restDataCount + bytesCount)
            dataLength = datalength[2:]
            bytesCount = hex(bytesCount)
            bytesCount = bytesCount[2:]
            
            cmdWriteUserMemory = ('52464501500402'+dataLength
                                  +'030c'+EPC+'03000000000000'
                                  +bytesCount+data+'04')
            
            from ReaderFunctions import CheckSum
            cmdWriteUserMemoryCS = CheckSum(cmdWriteUserMemory) #Calculate the checksum
            
            cmd = binascii.unhexlify(cmdWriteUserMemoryCS)
            from ReaderFunctions import SerialComm            
            
            data = SerialComm(ser, cmd) #Establish serial communication
            
            status = data[18:20]
            count = 0
            
            #if data not read try agin
            if len(data) == 24:
                return 'Wrote Successful'
            else:
                
                while status != '00' or len(data)!= 24:
                    if count < 15:
                        data = SerialComm(ser, cmd)
                        status = data[18:20]
                        count = count + 1
                        
                    else:
                        
                        break                            

                if status == '00':
                    
                    return 'Wrote Successful'
                else:
                    return "Tag unreachable"                    
       
    else:
        print"Cannot open serial port"

#-------------------------------------------------------------------------------
